{{ RealNumbers.spin}}

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000


VAR
   byte num[40]
   byte input[40]
   long done
   long key
   long size
   long num1, num2
   long counter
   long answer
   long operator

OBJ

  Term  :       "TV_Text"
  F     :       "dwdF32"
  FS    :       "dwdFloatString2"
  keyboard : "keyboard"

PUB Math
      
  F.start
  keyboard.start(26, 27)
  Term.Start(12)
       
  FS.SetPrecision(24)     
 repeat
    Term.Str(string("> ")) 
    'Get input
    repeat counter from 0 to 40
      input[counter] := keyboard.getKey
      if(input[counter] == 13) 'Enter key
        input[counter] := 0
        quit
      term.out(input[counter]) 

    'Parse first number
    repeat counter from 0 to 20
      if(input[counter] => "0" AND input[counter] =< "9" or input[counter] =="." ) 
        num[counter] := input[counter]
      else
        num[counter] := 0
        quit
    if(counter <> 0) 
      num1 := fs.StringToFloat(@num)
    else
      num1 := answer

    'Parse operator
    operator := input[counter]
    counter++

    bytemove(@input, @input+counter, 20)
    
    'Parse second number
    repeat counter from 0 to 20
      if(input[counter] => "0" AND input[counter] =< "9"or input[counter] ==".") 
        num[counter] := input[counter]
      else
        num[counter] := 0
        quit 
    num2 := fs.StringToFloat(@num)
 
    if operator == 42
      answer := F.FMUL(NUM1,NUM2)
    elseif operator == 47
      answer := F.FDIV(NUM1,NUM2) 
    elseif operator == 43
      answer := F.FADD(NUM1,NUM2) 
    elseif operator == "-"
      answer := F.FSUB(NUM1,NUM2) 
    elseif operator == "^"
      answer := F.Pow(NUM1,NUM2) 
    else
      answer := 0




  {Floating-point constants using FloatMath and FloatString objects}

  Term.Str(string("="))
  Term.Str(FS.FloatToString(answer))
  Term.Out(13) 
                                     